Subject: bug#32463: 27.0.50; (logior -1) => 4611686018427387903

From: Paul Eggert <[email-masked]>
Date: Sat, 18 Aug 2018 11:48:11 -0700

Pip Cet wrote:

> Paul committed a patch in the meantime (independently, I think?) which
> does add tests. I'll try to write some more.

Yes, I noticed the logior etc. problem separately and fixed it in master without 
knowing about this bug report. There are some other bignum problems too that 
need fixing and are in my pipeline.

> can we agree that lsh and ash behave
> the same for bignums?

It would be weird for lsh to act one way for negative bignums, and a different 
and incompatible way for negative fixnums. Instead, I suggest that we deprecate 
lsh, as it doesn't make sense any more now that integers have unbounded size. 
While we're deprecating it, we can make (lsh A B) signal an error if A is a 
bignum and B is negative, since there's nothing we can do there that is 
reasonable and is compatible with the fixnum behavior.